#include <owl\applicat.h>
#include <owl\framewin.h>
#include <owl\dialog.h>
#include <owl\dc.h>
#include <owl\edit.h>
#include "pr20_1.rc"

//   .
struct
{
  char nameEdit[81];
  char addrEdit[81];
  char cityEdit[26];
  char stateEdit[3];
  char zipEdit[11];
  char phoneEdit[20];
  char birthEdit[9];
} transBuf;

// 
class TApp: public TApplication
{
  public:
	 TApp():TApplication(){}
	 void InitMainWindow();
};

//  
class TWndw:public TFrameWindow
{
  public:
	 TWndw(TWindow *parent, const char far *title);
  protected:
	 void CmTestDialog();
         void Paint(TDC &paintDC,BOOL,TRect&);

	 DECLARE_RESPONSE_TABLE (TWndw);
};

DEFINE_RESPONSE_TABLE1 (TWndw, TFrameWindow)
  EV_COMMAND(CM_TESTDIALOG,CmTestDialog),
END_RESPONSE_TABLE;

//  
class TDlg:public TDialog
{
	public:
		TDlg(TWindow *parent,TResId resId);
};


TWndw::TWndw(TWindow *parent, const char far *title):
		  TFrameWindow(parent,title)
{
	//     .
	AssignMenu("MENU_1");
	//     .
	Attr.X=50;
	Attr.Y=50;
	Attr.W=GetSystemMetrics(SM_CXSCREEN)/4;
	Attr.H=GetSystemMetrics(SM_CXSCREEN)/5;
        //   . 
        memset (&transBuf, 0, sizeof(transBuf));
}

// TWndw::CmTestDialog()
//      Dialog/Test
//  Dialog.
void TWndw::CmTestDialog()
{
  //   .
  TDialog *dialog = new TDlg(this, ADDRDLG);
  //   .
  int result = dialog->Execute();
  //     ... 
  if (result == IDOK)
     //    
     //     . 
     Invalidate();
}

//TWndw::Paint()
//    
// TWindow Paint(),    WM_PAINT,
//  Windows   d , 
//   .
void TWndw::Paint(TDC &paintDC,BOOL,TRect&)
{
  TEXTMETRIC tm;
  //   .
  paintDC.GetTextMetrics(tm);
  //    .
  paintDC.SetTextAlign(TA_RIGHT);
  //    
  TSize size=paintDC.GetTextExtent("BIRTHDAY:",9);
  //      
  paintDC.TextOut(size.cx+12,tm.tmHeight,"NAME:");
  paintDC.TextOut(size.cx+12,tm.tmHeight*2,"ADDRESS:");
  paintDC.TextOut(size.cx+12,tm.tmHeight*3,"CITY:");
  paintDC.TextOut(size.cx+12,tm.tmHeight*4,"STATE:");
  paintDC.TextOut(size.cx+12,tm.tmHeight*5,"ZIP:");
  paintDC.TextOut(size.cx+12,tm.tmHeight*6,"PHONE:");
  paintDC.TextOut(size.cx+12,tm.tmHeight*7,"BIRTHDAY:");
  //    	 .
  paintDC.SetTextAlign(TA_LEFT);
  //     
  //   , 
  //         .  
  paintDC.TextOut(size.cx+20,tm.tmHeight,transBuf.nameEdit);
  paintDC.TextOut(size.cx+20,tm.tmHeight*2,transBuf.addrEdit);
  paintDC.TextOut(size.cx+20,tm.tmHeight*3,transBuf.cityEdit);
  paintDC.TextOut(size.cx+20,tm.tmHeight*4,transBuf.stateEdit);
  paintDC.TextOut(size.cx+20,tm.tmHeight*5,transBuf.zipEdit);
  paintDC.TextOut(size.cx+20,tm.tmHeight*6,transBuf.phoneEdit);
  paintDC.TextOut(size.cx+20,tm.tmHeight*7,transBuf.birthEdit);
}

// ************************
//   TDlg.
// ************************
// TDlg::TDlg()
//   .
TDlg::TDlg(TWindow *parent,TResId resId):
			TDialog(parent,resId)
{
  //    OWL  
  //   .
  new TEdit(this,IDC_NAME,sizeof(transBuf.nameEdit));
  new TEdit(this,IDC_ADDR,sizeof(transBuf.addrEdit));
  new TEdit(this,IDC_CITY,sizeof(transBuf.cityEdit));
  new TEdit(this,IDC_STATE,sizeof(transBuf.stateEdit));
  new TEdit(this,IDC_ZIP,sizeof(transBuf.zipEdit));
  new TEdit(this,IDC_PHONE,sizeof(transBuf.phoneEdit));
  new TEdit(this,IDC_BIRTH,sizeof(transBuf.birthEdit));
  //    .
  TransferBuffer=&transBuf;
}

void TApp::InitMainWindow()
{
  TFrameWindow *wndw=new TWndw(0,"    ");
  SetMainWindow(wndw);
  //   DLL 
  //    Borland.
  EnableBWCC();
}

int OwlMain(int,char *[])
{
  return TApp().Run();
}
